/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /local/robotpkg/var/tmp/robotpkg/wip/dptu-genom3/work/templates/ros/client/ros/dptu/msg/dptu_ptu_axis.msg
 *
 */


#ifndef DPTU_MESSAGE_DPTU_PTU_AXIS_H
#define DPTU_MESSAGE_DPTU_PTU_AXIS_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace dptu
{
template <class ContainerAllocator>
struct dptu_ptu_axis_
{
  typedef dptu_ptu_axis_<ContainerAllocator> Type;

  dptu_ptu_axis_()
    : value(0)  {
    }
  dptu_ptu_axis_(const ContainerAllocator& _alloc)
    : value(0)  {
    }



   typedef uint32_t _value_type;
  _value_type value;


    enum { dptu_PAN = 0u };
     enum { dptu_TILT = 1u };
 

  typedef boost::shared_ptr< ::dptu::dptu_ptu_axis_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::dptu::dptu_ptu_axis_<ContainerAllocator> const> ConstPtr;

}; // struct dptu_ptu_axis_

typedef ::dptu::dptu_ptu_axis_<std::allocator<void> > dptu_ptu_axis;

typedef boost::shared_ptr< ::dptu::dptu_ptu_axis > dptu_ptu_axisPtr;
typedef boost::shared_ptr< ::dptu::dptu_ptu_axis const> dptu_ptu_axisConstPtr;

// constants requiring out of line definition

   

   



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::dptu::dptu_ptu_axis_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::dptu::dptu_ptu_axis_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace dptu

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': True, 'IsMessage': True, 'HasHeader': False}
// {'dptu': ['dptu/msg'], 'actionlib_msgs': ['/opt/openrobots/share/actionlib_msgs/msg'], 'std_msgs': ['/opt/openrobots/share/std_msgs/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::dptu::dptu_ptu_axis_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::dptu::dptu_ptu_axis_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::dptu::dptu_ptu_axis_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::dptu::dptu_ptu_axis_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::dptu::dptu_ptu_axis_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::dptu::dptu_ptu_axis_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::dptu::dptu_ptu_axis_<ContainerAllocator> >
{
  static const char* value()
  {
    return "79ec0620744f1162f9c783c8b3e22a95";
  }

  static const char* value(const ::dptu::dptu_ptu_axis_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x79ec0620744f1162ULL;
  static const uint64_t static_value2 = 0xf9c783c8b3e22a95ULL;
};

template<class ContainerAllocator>
struct DataType< ::dptu::dptu_ptu_axis_<ContainerAllocator> >
{
  static const char* value()
  {
    return "dptu/dptu_ptu_axis";
  }

  static const char* value(const ::dptu::dptu_ptu_axis_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::dptu::dptu_ptu_axis_<ContainerAllocator> >
{
  static const char* value()
  {
    return "# IDL enum ::dptu::ptu_axis\n\
uint32 dptu_PAN = 0\n\
uint32 dptu_TILT = 1\n\
\n\
uint32 value\n\
";
  }

  static const char* value(const ::dptu::dptu_ptu_axis_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::dptu::dptu_ptu_axis_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.value);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct dptu_ptu_axis_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::dptu::dptu_ptu_axis_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::dptu::dptu_ptu_axis_<ContainerAllocator>& v)
  {
    s << indent << "value: ";
    Printer<uint32_t>::stream(s, indent + "  ", v.value);
  }
};

} // namespace message_operations
} // namespace ros

#endif // DPTU_MESSAGE_DPTU_PTU_AXIS_H
