/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /local/robotpkg/var/tmp/robotpkg/wip/dptu-genom3/work/templates/ros/client/ros/dptu/msg/monitor_positionGoal.msg
 *
 */


#ifndef DPTU_MESSAGE_MONITOR_POSITIONGOAL_H
#define DPTU_MESSAGE_MONITOR_POSITIONGOAL_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <dptu/dptu_ptu_axis.h>
#include <dptu/dptu_ptu_unit.h>

namespace dptu
{
template <class ContainerAllocator>
struct monitor_positionGoal_
{
  typedef monitor_positionGoal_<ContainerAllocator> Type;

  monitor_positionGoal_()
    : axis()
    , unit()  {
    }
  monitor_positionGoal_(const ContainerAllocator& _alloc)
    : axis(_alloc)
    , unit(_alloc)  {
    }



   typedef  ::dptu::dptu_ptu_axis_<ContainerAllocator>  _axis_type;
  _axis_type axis;

   typedef  ::dptu::dptu_ptu_unit_<ContainerAllocator>  _unit_type;
  _unit_type unit;




  typedef boost::shared_ptr< ::dptu::monitor_positionGoal_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::dptu::monitor_positionGoal_<ContainerAllocator> const> ConstPtr;

}; // struct monitor_positionGoal_

typedef ::dptu::monitor_positionGoal_<std::allocator<void> > monitor_positionGoal;

typedef boost::shared_ptr< ::dptu::monitor_positionGoal > monitor_positionGoalPtr;
typedef boost::shared_ptr< ::dptu::monitor_positionGoal const> monitor_positionGoalConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::dptu::monitor_positionGoal_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::dptu::monitor_positionGoal_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace dptu

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': True, 'IsMessage': True, 'HasHeader': False}
// {'dptu': ['dptu/msg'], 'actionlib_msgs': ['/opt/openrobots/share/actionlib_msgs/msg'], 'std_msgs': ['/opt/openrobots/share/std_msgs/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::dptu::monitor_positionGoal_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::dptu::monitor_positionGoal_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::dptu::monitor_positionGoal_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::dptu::monitor_positionGoal_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::dptu::monitor_positionGoal_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::dptu::monitor_positionGoal_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::dptu::monitor_positionGoal_<ContainerAllocator> >
{
  static const char* value()
  {
    return "f5c583e2437f1c0b13a7e69ef70e50e2";
  }

  static const char* value(const ::dptu::monitor_positionGoal_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0xf5c583e2437f1c0bULL;
  static const uint64_t static_value2 = 0x13a7e69ef70e50e2ULL;
};

template<class ContainerAllocator>
struct DataType< ::dptu::monitor_positionGoal_<ContainerAllocator> >
{
  static const char* value()
  {
    return "dptu/monitor_positionGoal";
  }

  static const char* value(const ::dptu::monitor_positionGoal_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::dptu::monitor_positionGoal_<ContainerAllocator> >
{
  static const char* value()
  {
    return "# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======\n\
# service monitor_position\n\
dptu_ptu_axis axis\n\
dptu_ptu_unit unit\n\
\n\
================================================================================\n\
MSG: dptu/dptu_ptu_axis\n\
# IDL enum ::dptu::ptu_axis\n\
uint32 dptu_PAN = 0\n\
uint32 dptu_TILT = 1\n\
\n\
uint32 value\n\
\n\
================================================================================\n\
MSG: dptu/dptu_ptu_unit\n\
# IDL enum ::dptu::ptu_unit\n\
uint32 dptu_DEG = 0\n\
uint32 dptu_RAD = 1\n\
uint32 dptu_STEP = 2\n\
\n\
uint32 value\n\
";
  }

  static const char* value(const ::dptu::monitor_positionGoal_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::dptu::monitor_positionGoal_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.axis);
      stream.next(m.unit);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct monitor_positionGoal_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::dptu::monitor_positionGoal_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::dptu::monitor_positionGoal_<ContainerAllocator>& v)
  {
    s << indent << "axis: ";
    s << std::endl;
    Printer< ::dptu::dptu_ptu_axis_<ContainerAllocator> >::stream(s, indent + "  ", v.axis);
    s << indent << "unit: ";
    s << std::endl;
    Printer< ::dptu::dptu_ptu_unit_<ContainerAllocator> >::stream(s, indent + "  ", v.unit);
  }
};

} // namespace message_operations
} // namespace ros

#endif // DPTU_MESSAGE_MONITOR_POSITIONGOAL_H
