/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /local/robotpkg/var/tmp/robotpkg/wip/dptu-genom3/work/templates/ros/client/ros/dptu/msg/openGoal.msg
 *
 */


#ifndef DPTU_MESSAGE_OPENGOAL_H
#define DPTU_MESSAGE_OPENGOAL_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <dptu/dptu_baudrate_profile.h>

namespace dptu
{
template <class ContainerAllocator>
struct openGoal_
{
  typedef openGoal_<ContainerAllocator> Type;

  openGoal_()
    : device()
    , baudrate()  {
    }
  openGoal_(const ContainerAllocator& _alloc)
    : device(_alloc)
    , baudrate(_alloc)  {
    }



   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _device_type;
  _device_type device;

   typedef  ::dptu::dptu_baudrate_profile_<ContainerAllocator>  _baudrate_type;
  _baudrate_type baudrate;




  typedef boost::shared_ptr< ::dptu::openGoal_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::dptu::openGoal_<ContainerAllocator> const> ConstPtr;

}; // struct openGoal_

typedef ::dptu::openGoal_<std::allocator<void> > openGoal;

typedef boost::shared_ptr< ::dptu::openGoal > openGoalPtr;
typedef boost::shared_ptr< ::dptu::openGoal const> openGoalConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::dptu::openGoal_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::dptu::openGoal_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace dptu

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'dptu': ['dptu/msg'], 'actionlib_msgs': ['/opt/openrobots/share/actionlib_msgs/msg'], 'std_msgs': ['/opt/openrobots/share/std_msgs/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::dptu::openGoal_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::dptu::openGoal_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::dptu::openGoal_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::dptu::openGoal_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::dptu::openGoal_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::dptu::openGoal_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::dptu::openGoal_<ContainerAllocator> >
{
  static const char* value()
  {
    return "a083351e7850aa444eda2a27e0c0f103";
  }

  static const char* value(const ::dptu::openGoal_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0xa083351e7850aa44ULL;
  static const uint64_t static_value2 = 0x4eda2a27e0c0f103ULL;
};

template<class ContainerAllocator>
struct DataType< ::dptu::openGoal_<ContainerAllocator> >
{
  static const char* value()
  {
    return "dptu/openGoal";
  }

  static const char* value(const ::dptu::openGoal_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::dptu::openGoal_<ContainerAllocator> >
{
  static const char* value()
  {
    return "# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======\n\
# service open\n\
string device\n\
dptu_baudrate_profile baudrate\n\
\n\
================================================================================\n\
MSG: dptu/dptu_baudrate_profile\n\
# IDL enum ::dptu::baudrate_profile\n\
uint32 dptu_BAUDRATE_DEFAULT = 0\n\
uint32 dptu_BAUDRATE_HIGHEST = 1\n\
\n\
uint32 value\n\
";
  }

  static const char* value(const ::dptu::openGoal_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::dptu::openGoal_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.device);
      stream.next(m.baudrate);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct openGoal_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::dptu::openGoal_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::dptu::openGoal_<ContainerAllocator>& v)
  {
    s << indent << "device: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.device);
    s << indent << "baudrate: ";
    s << std::endl;
    Printer< ::dptu::dptu_baudrate_profile_<ContainerAllocator> >::stream(s, indent + "  ", v.baudrate);
  }
};

} // namespace message_operations
} // namespace ros

#endif // DPTU_MESSAGE_OPENGOAL_H
